Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jcontrol.io
Class FileInputStream

    java.lang.Object
      jcontrol.io.FileInputStream

All Implemented Interfaces:
  BasicInputStream

    public class FileInputStream

extends Object
implements BasicInputStream

A `FileInputStream` obtains input bytes from a file in a file system. What files are available depends on the host environment.

`FileInputStream` is meant for reading streams of raw bytes such as image data.

Since:
  JCVM32 (Gimlin3+Gimlin4)

Constructor Summary
`FileInputStream(File file)` Creates a `FileInputStream` by opening a connection to an actual file, the file named by the `File` object `file` in the file system.
`FileInputStream(String name)` Creates a `FileInputStream` by opening a connection to an actual file, the file named by the path name `name` in the file system.

Method Summary
`int` | `available()` Returns the number of bytes that can be read from this file input stream without blocking.
`void` | `close()` Closes this file input stream and releases any system resources associated with the stream.
`protected void` | `finalize()` Free internal data structures used by this file object.
`void` | `mark(int readlimit)` NOTE: not supported!
`boolean` | `markSupported()` NOTE: not supported!
`int` | `read()` Reads a byte of data from this input stream.
`int` | `read(byte[] b)` Reads up to `b.length` bytes of data from this input stream into an array of bytes.
`int` | `read(byte[] b, int off, int len)` Reads up to `len` bytes of data from this input stream into an array of bytes.
`void` | `reset()` NOTE: not supported!
`int` | `skip(int n)` Skips over and discards `n` bytes of data from the input stream.

Methods inherited from class java.lang.Object
`clone, equals, getClass, notifyAll, toString, wait`

Constructor Detail

### FileInputStream

    public FileInputStream(String name)
                    throws FileNotFoundException,
                           IOException

  Creates a `FileInputStream` by opening a connection to an actual file, the file named by the path name `name` in the file system. A new `FileDescriptor` object is created to represent this file connection.

  If the named file does not exist, is a directory rather than a regular file, or for some other reason cannot be opened for reading then a `FileNotFoundException` is thrown.

  Parameters:
    `name` - the system-dependent file name.
  Throws:
    `FileNotFoundException` - if the file does not exist, is a directory rather than a regular file, or for some other reason cannot be opened for reading.
    `IOException`

### FileInputStream

    public FileInputStream(File file)
                    throws FileNotFoundException,
                           IOException

  Creates a `FileInputStream` by opening a connection to an actual file, the file named by the `File` object `file` in the file system. A new `FileDescriptor` object is created to represent this file connection.

  If the named file does not exist, is a directory rather than a regular file, or for some other reason cannot be opened for reading then a `FileNotFoundException` is thrown.

  Parameters:
    `file` - the file to be opened for reading.
  Throws:
    `FileNotFoundException` - if the file does not exist, is a directory rather than a regular file, or for some other reason cannot be opened for reading.
    `IOException`
  See Also:
    `File.getPath()`

Method Detail

### read

    public int read()
             throws IOException

  Reads a byte of data from this input stream. This method blocks if no input is yet available.

  Specified by:
    `read` in interface `BasicInputStream`
  Returns:
    the next byte of data or -1 if end of file reached.
  Throws:
    `IOException` - if an I/O error occurs.

### read

    public int read(byte[] b)
             throws IOException

  Reads up to `b.length` bytes of data from this input stream into an array of bytes. This method blocks until some input is available.

  Specified by:
    `read` in interface `BasicInputStream`
  Parameters:
    `b` - the buffer into which the data is read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the file has been reached.
  Throws:
    `IOException` - if an I/O error occurs.
  See Also:
    `InputStream.read(byte[], int, int)`

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws IOException

  Reads up to `len` bytes of data from this input stream into an array of bytes. This method blocks until some input is available.

  Specified by:
    `read` in interface `BasicInputStream`
  Parameters:
    `b` - the buffer into which the data is read.
    `off` - the start offset of the data.
    `len` - the maximum number of bytes read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the file has been reached.
  Throws:
    `IOException` - if an I/O error occurs.
  See Also:
    `InputStream.read()`

### skip

    public int skip(int n)
             throws IOException

  Skips over and discards `n` bytes of data from the input stream. The `skip` method may, for a variety of reasons, end up skipping over some smaller number of bytes, possibly `0`. The actual number of bytes skipped is returned.

  Specified by:
    `skip` in interface `BasicInputStream`
  Parameters:
    `n` - the number of bytes to be skipped.
  Returns:
    the actual number of bytes skipped.
  Throws:
    `IOException` - if an I/O error occurs.

### available

    public int available()
                  throws IOException

  Returns the number of bytes that can be read from this file input stream without blocking.

  Specified by:
    `available` in interface `BasicInputStream`
  Returns:
    the number of bytes that can be read from this file input stream without blocking.
  Throws:
    `IOException` - if an I/O error occurs.

### close

    public void close()
               throws IOException

  Closes this file input stream and releases any system resources associated with the stream.

  If this stream has an associated channel then the channel is closed as well.

  Specified by:
    `close` in interface `BasicInputStream`
  Throws:
    `IOException` - if an I/O error occurs.

### finalize

    protected void finalize()

  Free internal data structures used by this file object.

### mark

    public void mark(int readlimit)

  NOTE: not supported!

  Specified by:
    `mark` in interface `BasicInputStream`
  Parameters:
    `readlimit` - the maximum limit of bytes that can be read before the mark position becomes invalid.

### markSupported

    public boolean markSupported()

  NOTE: not supported!

  Specified by:
    `markSupported` in interface `BasicInputStream`
  Returns:
    `true` if this stream instance supports the mark and reset methods; `false` otherwise.

### reset

    public void reset()
               throws IOException

  NOTE: not supported!

  Specified by:
    `reset` in interface `BasicInputStream`
  Throws:
    `IOException` - if this stream has not been makred or if the mark has been invalidated.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD